//+------------------------------------------------------------------+
//|                                          TicksSeparateVolume.mq4 |
//|                                    Copyright  2008, FOREXflash. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, FOREXflash Software Corp."
#property link      "http://www.metaquotes.net"
//-----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_color1 Lime
#property indicator_color2 Red

extern double tickDiffLevel    = 50.0;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";

double UpTicks[];
double DnTicks[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   IndicatorBuffers(3);
   SetIndexBuffer(0,UpTicks); SetIndexStyle(0,DRAW_HISTOGRAM,0,3); SetIndexLabel(0,"UpTicks");
   SetIndexBuffer(1,DnTicks); SetIndexStyle(1,DRAW_HISTOGRAM,0,2); SetIndexLabel(1,"DownTicks");
   SetIndexBuffer(2,trend);
   IndicatorShortName("TicksSeparateVolume("+Symbol()+")");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  
   ObjectDelete("UpTicks1");
   ObjectDelete("DownTicks1");
   ObjectDelete("UpTicks2");
   ObjectDelete("DownTicks2");
   Comment("");
  
  return(0);
  }
//+------------------------------------------------------------------+
//| Ticks Volume Indicator                                           |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
   
   for(i=limit; i>=0; i--) UpTicks[i]=(Volume[i]+(Close[i]-Open[i])/Point)/2;
   for(i=limit; i>=0; i--) DnTicks[i]=Volume[i]-UpTicks[i];
   for(i=limit; i>=0; i--)
   {
      trend[i] = trend[i+1];
      if ((UpTicks[i]-DnTicks[i])>tickDiffLevel) trend[i] = 1;
      if ((DnTicks[i]-UpTicks[i])>tickDiffLevel) trend[i] =-1;
   }  
   string BV="BUYERS VOLUME: "+DoubleToStr(UpTicks[0],0)+"";
   string SV="SELLERS VOLUME: "+DoubleToStr(DnTicks[0],0)+"";
     
   
   ObjectCreate("UpTicks2", OBJ_LABEL, WindowFind("TicksSeparateVolume("+Symbol()+")"), 0, 0);
   ObjectSetText("UpTicks2",StringSubstr((BV),0), 10, "Tahoma" ,Lime);
   ObjectSet("UpTicks2", OBJPROP_CORNER, 0);
   ObjectSet("UpTicks2", OBJPROP_XDISTANCE, 6);
   ObjectSet("UpTicks2", OBJPROP_YDISTANCE, 22);
   
   ObjectCreate("DownTicks2", OBJ_LABEL, WindowFind("TicksSeparateVolume("+Symbol()+")"), 0, 0);
   ObjectSetText("DownTicks2",StringSubstr((SV),0), 10, "Tahoma" ,Red);
   ObjectSet("DownTicks2", OBJPROP_CORNER, 0);
   ObjectSet("DownTicks2", OBJPROP_XDISTANCE, 6);
   ObjectSet("DownTicks2", OBJPROP_YDISTANCE, 42);
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
 
      return(0);
  }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TicksSeparateVolume ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TicksSeparateVolume "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}